#include <iostream>
#include <mpi.h>
#include <stdint.h>
struct __carStoreStruct
{
        uint64_t _guid;
        uint32_t _path[700][2];
        uint32_t _cStreet;
        double _cSpeed;
        double _cMePosition;
        uint32_t pathSize;
};

using namespace std;

int main(int argc, char* argv[])
{
	MPI_Init(&argc, &argv);
	MPI_Request sendReq, rcvReq;
	MPI_Status sendStatus, rcvStatus;
	__carStoreStruct sendStruct, rcvStruct;
	MPI_Datatype _type;
	int b_Length[6]={1,1400,1,1,1,1};
        MPI_Aint t_disp[6]={0,8,5608,5616,5624,5632};
        MPI_Datatype m_types[6]={MPI_UNSIGNED_LONG, MPI_UNSIGNED, MPI_UNSIGNED, MPI_DOUBLE, MPI_DOUBLE, MPI_UNSIGNED};
        MPI_Type_create_struct(6, b_Length, t_disp, m_types, &_type);
        MPI_Type_commit(&_type);
	MPI_Aint lb, size;
	MPI_Type_get_true_extent(MPI_UNSIGNED_LONG_LONG, &lb, &size);
	cout << lb << "," << size << endl;
	sendStruct._guid = 1;
	rcvStruct._guid = 2;
	cout << sizeof(sendStruct) << endl;
	MPI_Isend(&sendStruct, 1, _type, 0, 0, MPI_COMM_WORLD, &sendReq);
	MPI_Irecv(&rcvStruct, 1, _type, 0, 0, MPI_COMM_WORLD, &rcvReq);
	MPI_Wait(&rcvReq, &rcvStatus);
	cout << rcvStruct._guid << endl; 
	MPI_Finalize();
}
